import { AnyT, IKeyValue } from '../definitions.interface';
import { IValidationResultEntity, ValidatorRuleEnum } from '../definition';
/**
 * @stable [06.12.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const optionalNumberLikeChecker: (value: AnyT) => boolean;
/**
 * @stable [06.12.2019]
 * @param value
 * @returns {boolean}
 */
export declare const stringChecker: (value: any) => boolean;
/**
 * @stable [06.12.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const notEmptyString: (value: AnyT) => boolean;
/**
 * @stable [06.12.2019]
 * @param value
 * @returns {boolean}
 */
export declare const digitChecker: (value: any) => boolean;
/**
 * @stable [28.01.2019]
 */
export declare const ValidationRules: {
    0: (value: any) => boolean;
    1: (value: AnyT) => boolean;
    2: (value: AnyT) => boolean;
    4: (value: AnyT) => boolean;
    5: (value: any) => boolean;
};
/**
 * @stable [17.04.2020]
 * @param {{[K in keyof TEntity]?: ValidatorRuleEnum[]}} payloads
 * @param {TEntity} checkedObject
 * @returns {IValidationResultEntity}
 */
export declare const validate: <TEntity extends IKeyValue = IKeyValue>(payloads: { [K in keyof TEntity]?: ValidatorRuleEnum[]; }, checkedObject: TEntity) => IValidationResultEntity;
